package lib

import (
	"math/rand"
	"strings"
	"time"
)

// #取得随机字符串：通过打乱slice来操作
func GetRandstring(length int, char string, rand_x int64) string {
	if length < 1 {
		return ""
	}

	if len(char) <= 6 || len(char) <= length {
		char = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
	}

	charArr := strings.Split(char, "")
	ran := rand.New(rand.NewSource(time.Now().Unix() + rand_x))

	l := len(charArr)
	for i := l - 1; i > 0; i-- {
		r := ran.Intn(i)
		charArr[r], charArr[i] = charArr[i], charArr[r]
	}
	rchar := charArr[:length]
	return strings.Join(rchar, "")
}

// 检查日期格式
func IsDateStr(date string) bool {
	if _, err := time.Parse("2006-01-02", date); err != nil {
		return false
	}
	return true
}

func SplitStringIds(str string, prefix string) (r []string) {
	Ids_str := strings.TrimRight(str, "|")
	Ids := strings.Split(Ids_str, "|")
	for _, v := range Ids {
		r = append(r, strings.TrimLeft(v, prefix))
	}
	return r
}
